#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <gtk/gtk.h>

#define VERSION "1.2"
#define PIXMAPWIDTH 1600
#define PIXMAPHEIGHT 1200

#define MAXCL 80
#define Hex 1    /* define angletypes and textdirect. , DONT CHANGE THEM !*/
#define Pent 2
#define Pent_switch 3
#define Octa 4
#define No_angle 0
#define Left_Text 0 
#define Middle_Text -1
#define Right_Text -2
#define False 0
#define True 1
extern struct data {
            int x,y;
            int tx,ty;
	    int bond;
            int smarked,tmarked;
	    struct data *next;
	    struct data *prev; 
	    } da_root, *new;

extern struct dc {
	    int x,y;
	    char c[MAXCL];
	    int direct;
	    int marked;
	    struct dc *next;
	    struct dc *prev; 
  	  } dac_root, *new_c;

extern struct data_head {
	    int pix_width, pix_height;
	    int width, height;
	    } head;
  
extern struct new {
	   int x,y;
	   int tx,ty;
	   int n, nc;
	   } hp; 

extern struct xy_co {
	    int x,y;
	    int tx,ty;
	    } xycoord[30];

extern struct marked {
	   int x,y;
	   int w, h;
	   int flag;
	   } mark; 



extern float size_factor; 
extern int zoom_factor;

extern int draw_angle;
extern int text_direct;
extern int font_type;
extern int line_type;
extern int modify;
extern int addflag;
extern int oldatoms;
extern int oldlabels;
extern int xref,yref;

/*	chemproc.c	*/

extern struct data *select_vector(int mx, int my, float s_f);
extern void add_struct(int x,int y,int tx, int ty, int bond, int smarked, int tmarked);
extern int round_coord(int i, float step);
extern void del_char(struct dc *hpc);
extern void del_struct(struct data *hpc);
extern void add_char(int x,int y, char *c, int direct, int marked);
extern struct dc *select_char(int mx, int my, float s_f);
extern struct xy_co *calc_angle(int x, int y, int ang_type, int angle);
extern struct xy_co *position(int x, int y, int ax, int ay, int ang_type);
extern void setup_data(void);
extern void clear_data(void);
extern int partial_delete(int x, int y, int tx, int ty);
extern void center_mol(void);
extern int move_pos(int x, int y, int tx, int ty);
extern int check_pos_rec(int x, int y, int rx, int ry, int rtx, int rty);
extern int partial_move(int x, int y, int tx, int ty, int dx, int dy);
extern int partial_rotate(int xcent, int ycent, double rotsin, double rotcos);

extern int calc_vector(int dx, int dy);
extern struct xy_co *multi_bonds(int mx, int my, int mtx, int mty, int r);
extern struct xy_co *center_double_bond(int mx,int my,int mtx, int mty, int r);
struct xy_co *bond_cut(int x, int y, int tx, int ty, int r);

/*	graph.c	*/

extern void CreatePix(GtkWidget *drawing_area, GdkPixmap *picture );
extern void FreePix(GtkWidget *drawing_area, GdkPixmap *picture );
extern void CopyPlane(GtkWidget* drawing_area, GdkPixmap *picture );
extern void Display_Mol(GtkWidget *drawing_area, GdkPixmap *picture);
extern void Drawline();
extern void DrawDotted();
extern void DrawWide();
extern void DrawWedge();
extern void DrawDashedWedge();
extern void DrawArrow();
extern void DrawWiggly();
extern void Drawstring();
extern void DrawCircle();
extern int Extra_char(char c);
extern int Load_Font();
extern void Set_Line(GtkWidget *window, int lsty);

/*	draw.c	*/

extern void Add_double();
extern void Add_vector();
extern void Del_vector();
extern void Set_vector();
extern void Put_vector();
extern void Invert_vector();
extern void Add_atom();
extern void Del_atom();
extern void Set_start_rec();
extern void Put_rec();
extern void Del_rec();
extern void Mark_rec();
extern void Mark_atom();
extern void Center();
extern void Put_pmove();
extern void Set_pmove();
extern void Put_protate();

/*	dialog.c	*/

extern void  Puttext();
/****extern Widget MakeStringBox();****/
extern void FileCallback();
/****extern String GetString();****/
extern void Load();
extern void Add();
extern void Save();
extern void Export();
extern void Close_Export();
extern void XBM_Export();
extern void XPM_Export();
extern void Xfig_Export();
extern void PS_Export();
extern void LaTeX_Export();
extern void PS_Export();
extern void Quit();
extern void Really_Quit();
extern void New();
extern void Really_New();
extern void Zoom();
extern void Change_Text();
extern void Change_Angle();
extern void Edit_Mol();
extern void UnMark();
/****extern Widget toggle_icon();
extern String filetoload;****/
extern void do_load_file();
extern void flip_horiz();
extern void flip_vert();
extern void copy_obj();
/*	inout.c	*/

extern int save_mol(char *filename);
extern int load_mol(char *filename);
extern int add_mol(char *filename);
extern int export_bitmap(char *filename,GtkWidget *drawing_area,GdkPixmap *picture);
extern int export_xfig(char *filename);
extern int export_latex_pic(char *filename);
extern int export_ps_pic(char *filename);
extern int export_ps_pic(char *filename);
/****extern Cursor mycursor;****/

#ifdef LIBUNDO
extern int undo_free();
extern int undo_malloc();
extern int undo_snapshot();
#endif

extern void save_mol2();
extern GdkPixmap *picture;
extern GtkWidget *drawing_area;
extern GtkWidget *textbox;
/*int drawmode;*/  
extern int xcent,ycent;
extern int invflag;
extern int tmpx[200],tmpy[200];
